#include <stdlib.h>
#include "btree.h"

/*
 * This function creates and writes to disk the original root
 * of the newly created B-Tree. Initially, the root will
 * contain zero keys and no rightmost child.
 */
void create_root() {
    printf("Creating B-tree root page ... ");
    /* Install the header of new page */
    PageHdr* page_ptr = (PageHdr*) malloc(sizeof(PageHdr));
    check_malloc(page_ptr, "page_ptr");
    page_ptr->page_type          = LEAF_SYMBOL;
    page_ptr->page_num           = ROOT;
    page_ptr->next_leaf_page_num = NULL_PAGE_NUM;
    page_ptr->key_list_ptr       = NULL;  /* no keys yet */
    flush_page(page_ptr);  /* fills in #bytes & #keys */
    printf("Done \n");
}

