#include "btree.h"

/*
 * This function frees the space that was dynamimcally secured to hold a disk page.
 */
void free_page(PageHdr* page_ptr) {
    KeyRecord* next_victim;     /* Pointer to the list of keys */
    KeyRecord* current_victim;  /* Pointer to the list of keys */

    /* Free the keys */
    next_victim = page_ptr->key_list_ptr;
    while (next_victim != NULL) {
        current_victim = next_victim;
        next_victim    = next_victim->next;
        free(current_victim->stored_key);
        free(current_victim);
    }

    /* Free the page header */
    free(page_ptr);
}

