#include "postings.h"

/*
 * this function adds the block at the passed postings pointer (pptr) to the
 * freelist of the size (size).
 *
 * The file pointer cannot be assumed to be in the original position after
 * executing this function.
 */

void free_record(long pptr, long size) {
    int  i = 0, n = 0;
    long dummy, head, save;

    rewind(fp_postings);
    /* find index of proper freelist */
    while (LIST_SIZE[i] < size)
        i++;
    /* appropriate size list is now of size LIST_SIZE[i] */

    /* read through all freelist heads of smaller size to just before appropriate head */
    for (n = 0; n < i; n++)
        fread(&dummy, sizeof(dummy), 1, fp_postings);

    /* record position of file pointer */
    save = ftell(fp_postings);

    /* read in old freelist head */
    fread(&head, sizeof(head), 1, fp_postings);
    /* move file pointer back one to write new head */
    fseek(fp_postings, (long) save, 0);
    /* write passed pointer (pptr) as head of freelist */
    fwrite(&pptr, sizeof(pptr), 1, fp_postings);

    /* now update next pointer of new block */
    fseek(fp_postings, (long) pptr, 0);
    fwrite(&head, sizeof(head), 1, fp_postings);
}
