#include "postings.h"
#include "../docs/docs.h"

/*
 * This function prints all the docs pointed to by the postings list at the given offset.
 * Reading the postings list requires only one disk read, since all postings pointers
 * are stored contiguously.
 *
 * Modified by Frank Andrasco
 */
void print_postings(long offset) {
    fseek(fp_postings, offset, 0);

    long num_doc_offsets;
    fread(&num_doc_offsets, sizeof(num_doc_offsets), 1, fp_postings);

    for (int i = 0; i < num_doc_offsets; i++) {
        long doc_offset;
        fread(&doc_offset, sizeof(doc_offset), 1, fp_postings);
        printf("-------document #%d-----\n", i+1);
        print_doc(doc_offset);
    }
    printf("\n");
}
